import { IconDefinition } from "@fortawesome/pro-solid-svg-icons"

export interface Position {
  x: number
  y: number
}
export interface Target extends Position {
  show: boolean
}
export interface MouseCursor extends Position {
  shouldShow: boolean
}
export interface TargetList extends Position {
  type: string
  edges: string[]
}
export interface Mode {
  pointerGrid: any[][]
  type: string
}
export interface ItemProps {
  icon: string | IconDefinition
  text: string
  amount?: number
  iconColor?: string
  disabled?: boolean
  callback?: () => void
}
export interface EventBarModes {
  main: ItemProps[]
  menu: ItemProps[]
  attack: ItemProps[]
  draw: ItemProps[]
  settings: ItemProps[]
}
export interface Field extends Position {
  field: string
}
export interface Hit extends Position {
  hit: boolean
}

interface fireMissile {
  type: "fireMissile" | "htorpedo" | "vtorpedo"
  payload: {
    x: number
    y: number
    hit: boolean
  }[]
}
interface removeMissile {
  type: "removeMissile"
  payload: {
    x: number
    y: number
    hit: boolean
  }
}

export type HitDispatch = fireMissile | removeMissile

export interface Point {
  x: number
  y: number
}

export interface DrawLineProps {
  currentPoint: Point
  prevPoint: Point | null
  color: string
}

export interface Draw extends DrawLineProps {
  ctx: CanvasRenderingContext2D
}

export interface Ship extends Position {
  size: number
  variant: number
}
